<?php
/* *** ** * fastIce Framework.
** *
*
	fastIce alpha 0.43 © 2010~2011 noferi Mickaël/m2m - noferov@gmail.com - Some Rights Reserved.

	Except where otherwise noted, this work is licensed under a Creative Commons Attribution 3.0 License, CC-by-nc-sa
	terms of licence CC-by-nc-sa are readable at : http://creativecommons.org/licenses/by-nc-sa/3.0/
*
** *
* ** *** */

/*

changelog for 0.43
	- simplification and real declaration of addToKw and setKw functions
	- now render keywords use standard cache, so, each specific adition of each page piece are saved independally
		so, remove noRenderCache() function, also, nodesigncache var is reset at each getdesign, so use noDesignCache() once in a page piece or module call or load, to not get any cache, for html output or js/jquery or other addition.
	- optimize skeleton and ini load, use redis design cache if possible, -> less redis call or them are pipelined, more performance and time stability
	- exemple page is now completely generated in 1.3 to 1.6ms (when cached) on my dual core 1200mhz celeron, in general, less or equeal to 1.4ms.

changelog for 0.42
	- squeleton and page ini files are now cached in redis.
	- render page specific keywords (title, js, jquery,..) are cached too, so, now js included in a plugin still here, and you can cache your plugin too
		cache of this keywords are done on addToKw or setKw function, the noRenderCache() function is here to not cache this info.

*/

// global config .......................................

define ('template','fr');

define('redisServer','127.0.0.1');
define('redisPrefix','laphrodite');

define('site_url','/redis/');
//define('site_full_url','http://votreIpOuDomaine/redis/');

define('defaultTitle','titre par default');
define('defaultKeywords','mot clef par default');
define('defaultDescription','description par default');
define('defaultMeta','');

setlocale (LC_ALL, 'fr_FR.utf8','fra');
ini_set('display_errors', 1);
set_time_limit(0);

/* ********************* **/

define('includeChar','§');
//define('callbackChar','$');
define('callbackStart','$');
define('callbackEnd','$');
define('includeWordSize','4,2048');
//define('callbackWordSize','4,16');
define ('includePattern','/'.includeChar.'([^'.includeChar.']{'.includeWordSize.'})'.includeChar.'/u');
//define ('callbackPattern','/'.callbackChar.'([^'.callbackChar.']{'.callbackWordSize.'})'.callbackChar.'/u');
define ('noFollowKeyWord','[$$]');

global $nofollow,$nodesigncache,$norendercache,$renderInclude,$redis,$global_current_file,$fnc,$designPath,$commonDesignPath,$currentDesign;
$redis = new Redis(); if(!$redis->connect(redisServer)) die('cannot rape the database ...');

if(isset($_GET['deleteCache']))
{	$cache = $redis->keys(redisPrefix.':designCache:*');
	foreach($cache as $c) $redis->delete($c);
}

define ('site_full_path',dirname(__FILE__));
define ('site_path',site_full_path.'/files');
define ('common_path','commun');
define ('module_path','modules');

$nofollow=0;$nodesigncache=0;$norendercache=0;$renderInclude=array();$global_current_file='';$fnc=array();$designPath='';$commonDesignPath='';
/* additionnal keywords for render */
function addToRender($word,$txt) { global $renderInclude,$currentDesign; $renderInclude[$word] .= $txt; setDesignCache($currentDesign.'/'.$word,$txt); }
function setRender($word,$txt) { global $renderInclude,$currentDesign; $renderInclude[$word] = $txt; setDesignCache($currentDesign.'/'.$word,$txt); }
global $renderWords; $renderWords = array('head','js','jquery','title','meta','style','keywords','description');

function addToHead($t){addToRender('head',$t);}function setHead($t){setRender('head',$t);}$renderInclude['head']='';function addToJs($t){addToRender('js',$t);}function setJs($t){setRender('js',$t);}$renderInclude['js']='';function addToJquery($t){addToRender('jquery',$t);}function setJquery($t){setRender('jquery',$t);}$renderInclude['jquery']='';function addToTitle($t){addToRender('title',$t);}function setTitle($t){setRender('title',$t);}$renderInclude['title']='';function addToMeta($t){addToRender('meta',$t);}function setMeta($t){setRender('meta',$t);}$renderInclude['meta']='';function addToStyle($t){addToRender('style',$t);}function setStyle($t){setRender('style',$t);}$renderInclude['style']='';function addToKeywords($t){addToRender('keywords',$t);}function setKeywords($t){setRender('keywords',$t);}$renderInclude['keywords']='';function addToDescription($t){addToRender('description',$t);}function setDescription($t){setRender('description',$t);}$renderInclude['description']='';
//foreach($renderWords as $word){ print('function addTo'.ucfirst($word).'($t){addToRender(\''.$word.'\',$t);}function set'.ucfirst($word).'($t){setRender(\''.$word.'\',$t);}$renderInclude[\''.$word.'\']=\'\';'); } die();

function renderPage($page)
{	global $renderInclude;
	foreach($renderInclude as $word => $value)
	{	$page = str_replace('['.$word.']', $value, $page);
		
	} print $page;
}

function get_include_contents($filename)
{	if(is_file($filename))
	{	//$start = microtime(true);
		ob_start(); include ($filename); $contents = ob_get_contents(); ob_end_clean();
		//print '<br>load '.$filename.' in '.((microtime(true)-$start)*1000);
		return $contents;
	} return false;
}

function showPage($string,$seed=0)
{	global $fnc,$global_current_file,$global_constants,$need_fix_name,$designPath,$commonDesignPath,$redis;
//	$start = microtime(true);
	$key = $string[1];

	if($seed){ $designPath=$key; $commonDesignPath=''; }

 	$dpath = $designPath; $cdpath = $commonDesignPath;

	$out = '';
	if($seed)
	{	global $seedPath,$design_cache; $seedPath=$key;

		$redis->multi(Redis::PIPELINE)->hgetall(redisPrefix.':designCache:'.$seedPath)->hgetall(redisPrefix.':designCache:pages:'.$key);
		list($design_cache,$page_opt) = $redis->exec();

		if(empty($page_opt)) // redis page info not set
		{	$path = template.'/'.$key.'/'.$key.'.ini';
			if(is_file($path))
			{	$page_opt = parse_ini_file($path); $redis->hMset(redisPrefix.':designCache:pages:'.$key,$page_opt);
			}
		}

		if(!isset($page_opt['skeleton'])) $page_opt['skeleton'] = 'normal';
		if(!isset($page_opt['title'])) $page_opt['title'] = defaultTitle;
		if(!isset($page_opt['keywords'])) $page_opt['keywords'] = defaultKeywords;
		if(!isset($page_opt['description'])) $page_opt['description'] = defaultDescription;
		if(!isset($page_opt['meta'])) $page_opt['meta'] = defaultMeta;

		global $renderInclude;
		$renderInclude['title'] = $page_opt['title'];
		$renderInclude['keywords'] = $page_opt['keywords'];
		$renderInclude['description'] = $page_opt['description'];

		if(!isset($design_cache['sk']))
		{	$path = template.'/'.common_path.'/skeleton/'.$page_opt['skeleton'].'.html';
			if(is_file($path))
			{	$out = file_get_contents($path); $redis->hset(redisPrefix.':designCache:'.$seedPath,'sk',$out);
			} else $out = '<h3>no valid skeleton</h3><br><b>'.$path.'</b>';
		} else $out = $design_cache['sk'];

	} else {
		$global_current_file = $key;
		$out = getDesign($key);
		$designPath .= '/'.$key; $commonDesignPath .= '/'.$key;
	}

	global $renderWords,$renderInclude;
	foreach($renderWords as $w)
	{	$d = getDesignCache($w);
		if($d !== false) $renderInclude[$w] .= $d;
	}

	if($out && $out!='') $out = preg_replace_callback(includePattern,'showPage',$out); else $out = '';

	if($seed && $need_fix_name) $out = str_replace(noFollowKeyWord, includeChar, $out);
	$designPath = $dpath; $commonDesignPath = $cdpath;

	return $out;
}

function getArgs($string,$word,$separator)
{	$wordSize = strlen($word);
	if(substr($string,0,$wordSize) == $word)
	{	$args = substr($string,$wordSize);
		$args = explode($separator,$args);
		array_unshift($args,count($args));
		return $args;
	}	return array(0);
}

global $design_cache;
function noDesignCache(){global $nodesigncache;$nodesigncache=1;}
function setDesignCache($design,$content)
{	global $nodesigncache,$seedPath,$designPath,$redis;
	if(!$nodesigncache)
		$redis->hset(redisPrefix.':designCache:'.$seedPath,$designPath.'/'.$design,$content);
}

function getDesignCache($design)
{	global $design_cache,$designPath,$redis;
	$k = $designPath.'/'.$design;
	if(isset($design_cache[$k]))
	{	//print '<br>load '.$k.' from cache';
		return $design_cache[$k];
	}//	print '<br>'.$k.' not in cache !';
	return false;
}

function setRedisDesign($name,$design)
{	global $redis;
	$list = redisPrefix.':design:'.template;
	$key = $list.'/'.$name;
	$redis->sadd($list,$name);
	$redis->set($key,$design);
}

function getDesign($design)
{	if($design == '') return ''; $d = getDesignCache($design); if($d !== false) return $d;
	global $nofollow,$last_design,$need_fix_name,$redis,$nodesigncache,$currentDesign; $nodesigncache=0; $currentDesign=$design;
	if($design == 'nofolow'){ $nofollow=1; $need_fix_name=1; return ''; }
	if($design == 'folow'){   $nofollow=0; return ''; }
	if($nofollow) { return noFollowKeyWord.$design.noFollowKeyWord; }
	global $designPath,$commonDesignPath;

	// search design in the template folder, absolute path
	$path = template.'/'.$designPath.'/'.$design.'.php'; // template folder
//	print '<br>try to get file "'.$path.'"';
	if(file_exists($path)) { $d=get_include_contents($path);if($d) { setDesignCache($design,$d); return $d; } }

	// search design in the common template folder, absolute path
	$path = template.'/'.common_path.$commonDesignPath.'/'.$design.'.php'; // template folder
//	print '<br>try to get file "'.$path.'"';
	if(file_exists($path)) { $d=get_include_contents($path);if($d) { setDesignCache($design,$d); return $d; } }

	// search design in the common folder, absolute path
	$path = common_path.$commonDesignPath.'/'.$design.'.php'; // common folder
//	print '<br>try to get file "'.$path.'"';
	if(file_exists($path)) { $d=get_include_contents($path);if($d) { setDesignCache($design,$d); return $d; } }

	// search design in the common template folder, just file, no path
	$path = template.'/'.common_path.'/'.$design.'.php'; // template folder
//	print '<br>try to get file "'.$path.'"';
	if(file_exists($path)) { $d=get_include_contents($path);if($d) { setDesignCache($design,$d); return $d; } }

	// search design in the common folder, just file, no path
	$path = common_path.'/'.$design.'.php'; // common folder
//	print '<br>try to get file "'.$path.'"';
	if(file_exists($path)) { $d=get_include_contents($path);if($d) { setDesignCache($design,$d); return $d; } }

	$separator = '|';
	$mdl = explode($separator,$design);
	if(isset($mdl[0]))
	{	$mdl = $mdl[0];
		$mdlargs = getArgs($design,$mdl.$separator,$separator);
		if($mdlargs[0] > 0)
		{	$fn = 'fn_'.$mdl;
			ob_start();
			if(function_exists($fn)) $fn($mdlargs);
			else	{	$path = module_path.'/'.$mdl.'/'.$mdl.'.php';
					if(is_file($path))
					{	//print '<b> load module '.$mdl.' </b>';
						include($path); $fn($mdlargs);
					}// else { print '<br>module not found or invalid : <b>'.$mdl.'</b><br>args : '; print_r($mdlargs); }
				}
			$out = ob_get_contents(); ob_end_clean();
			setDesignCache($design,$out); return $out;
		}
	}

	//print '<br> design '.$design.' not found !';
	return '';
}

/*function isUserPrivilege($prv)
{ return (isset($_SESSION['user']) && isset($_SESSION['user'][$prv]) && $_SESSION['user'][$prv]);
}*/

?>